/*
*	Status Icons for HLDM
*	    combined lj_icon,weapon_icon and kills counter
*
*				      by GordonFreeman
*			    http://www.lambda-force.org/
*/

#include <amxmodx>
#include <fakemeta_util>

new statusicon,lj,wi,ks,g_maxplayers
new user_weapon_icons[33][16]
new user_kills[33],clor[3]

new const g_nums[][] = {
	"",
	"number_1",
	"number_2",
	"number_3",
	"number_4",
	"number_5",
	"number_6",
	"number_7",
	"number_8",
	"number_9",
	"number_0"
}

new const g_weapon_sprites[][16] = {
	"cross",
	"d_crowbar",
	"d_9mmhandgun",
	"d_357",
	"d_9mmAR",
	"cross",
	"d_crossbow",
	"d_shotgun",
	"d_rpg_rocket",
	"d_gauss",
	"d_egon",
	"d_hornet",
	"d_grenade",
	"d_tripmine",
	"d_satchel",
	"d_snark"
}

new const g_weapon_clips[] = {
	0,
	0,
	17,
	6,
	50,
	0,
	5,
	8,
	1,
	70,
	70,
	8,
	8,
	5,
	5,
	15
}

public plugin_precache(){
	register_plugin("Status Icons","0.3","GordonFreeman")
	
	register_cvar("longjump_icon","0.1",FCVAR_SERVER|FCVAR_EXTDLL|FCVAR_SPONLY)
	register_cvar("weapon_icon","1.3",FCVAR_SERVER|FCVAR_EXTDLL|FCVAR_SPONLY)
	register_cvar("kills_counter_icon","0.2",FCVAR_SERVER|FCVAR_EXTDLL|FCVAR_SPONLY)
	
	statusicon = engfunc(EngFunc_RegUserMsg,"StatusIcon",-1)
	g_maxplayers = get_maxplayers()
	
	register_cvar("longjump_icon_on","1")
	register_cvar("weapon_icon_on","1")
	register_cvar("ks_on","1")
	register_cvar("ks_color","255 255 0")
}

public plugin_cfg(){
	lj = get_cvar_num("longjump_icon_on")
	wi = get_cvar_num("weapon_icon_on")
	ks = get_cvar_num("ks_on")
	
	if(lj)
		register_event("ItemPickup","show_lj_icon","b","1&item_longjump")
		
	if(wi){
		register_event("CurWeapon", "update_weapon_icon", "be", "1=1")
		register_event("AmmoX", "draw_weapon_icon", "be")
	}
	
	if(ks){
		new data[20],raw[3][5]
		get_cvar_string("ks_color",data,19)
		
		parse(data,raw[0],4,raw[1],4,raw[2],4)
		
		clor[0] = str_to_num(raw[0])
		clor[1] = str_to_num(raw[1])
		clor[2] = str_to_num(raw[2])
	}
	
	register_event("DeathMsg","death_event","a")
}

public update_weapon_icon(id)
{
	remove_weapon_icon(id)
		
	if(is_user_bot(id))
		return
		
	static wid
	wid = get_user_weapon(id)
	
	user_weapon_icons[id] = g_weapon_sprites[wid<16?wid:0]
	
	draw_weapon_icon(id)
	
	return
} 


public draw_weapon_icon(id)
{
	static iwpn,ammo,iclip,clip,icon_color[3]
	
	iwpn = get_user_weapon(id,clip,ammo)
	
	if(iwpn>16)
		iwpn = 0
	
	
	switch(iwpn){
		case HLW_GLOCK,HLW_PYTHON,HLW_MP5,HLW_SHOTGUN,HLW_CROSSBOW,HLW_RPG: iclip = clip
		default: iclip = ammo
	}
	
	// clip check, this is for the color of the icon
	if(!iclip&&iwpn!=HLW_CROWBAR)
		icon_color = {255, 0, 0} 	// outta ammo!
	else if(g_weapon_clips[iwpn]/2>=iclip)
		icon_color = {255,160,0}	// half way to outta ammo
	else 
		icon_color = {128, 255, 0}	// green icon...decent ammo
	
	// draw the sprite itself
	engfunc(EngFunc_MessageBegin, MSG_ONE,statusicon,{0,0,0},id)
	write_byte(1) 				// status (0=hide, 1=show, 2=flash)
	write_string(user_weapon_icons[id]) 	// sprite name
	write_byte(icon_color[0]) 		// red
	write_byte(icon_color[1]) 		// green
	write_byte(icon_color[2]) 		// blue
	message_end()
}


public remove_weapon_icon(id) 
{
	engfunc(EngFunc_MessageBegin,MSG_ONE,statusicon,{0,0,0},id)
	write_byte(0)
	write_string(user_weapon_icons[id])
	message_end()
}


public death_event() 
{
	static killer,id
	killer = read_data(1)	// t3h 0\|/n3|2
	id = read_data(2) 		// the dead player's ID (1-32)
	
	if(0<killer<=g_maxplayers){
		if(get_user_team(killer)!=get_user_team(id))
			icon(killer,1)
	}
	
	icon(id,0)
	
	if(wi)
		remove_weapon_icon(id)
	
	if(fm_get_user_longjump(id)&&lj){
		engfunc(EngFunc_MessageBegin,MSG_ONE,statusicon,{0.0, 0.0, 0.0},id)
		write_byte(0)
		write_string("item_longjump")
		message_end()
	}
}

public icon(id,style){
	if(!ks)
		return PLUGIN_CONTINUE
	
	if(!style){
		if(!user_kills[id])
			return PLUGIN_CONTINUE
			
		engfunc(EngFunc_MessageBegin,MSG_ONE,statusicon,{0,0,0},id)
		write_byte(0) 
		write_string(g_nums[user_kills[id]])
		message_end()
		
		user_kills[id] = 0
		
		return PLUGIN_CONTINUE
	}
	
	if(user_kills[id]>0){
		engfunc(EngFunc_MessageBegin,MSG_ONE,statusicon,{0,0,0},id)
		write_byte(0) 
		write_string(g_nums[user_kills[id]])
		message_end()
	}
	
	user_kills[id] ++

	if(user_kills[id]<10){
		engfunc(EngFunc_MessageBegin,MSG_ONE,statusicon,{0,0,0},id)
		write_byte(1) 
		write_string(g_nums[user_kills[id]])
		write_byte(clor[0])
		write_byte(clor[1])
		write_byte(clor[2])
		message_end()
	}else{
		icon(id,0)
		icon(id,1)
	}
	
	return PLUGIN_CONTINUE
}

public show_lj_icon(id){
	engfunc(EngFunc_MessageBegin,MSG_ONE,statusicon,{0.0, 0.0, 0.0},id)
	write_byte(1)
	write_string("item_longjump")
	write_byte(255)
	write_byte(127)
	write_byte(0)
	message_end()
}
